#include <stdlib.h>
#include <stdio.h>
#include <avr/io.h>
#include "1wire.h"
#include "tempmeas.h"
//#include "usart.h"

#define DS_TEMP_LS 0
#define DS_TEMP_MS 1
#define DS_TH 2
#define DS_TL 3
#define DS_RES1 4
#define DS_RES2 5
#define DS_REM 6
#define DS_PER 7
#define DS_CRC 8

void init_meas( unsigned char resolution ) { // resolution in Bit (9 Bit: 0 - 12 Bit: 3)
	uchar id[8], diff;

	for( diff = SEARCH_FIRST; diff != LAST_DEVICE; ){
		diff = w1_rom_search( diff, id );
		if( diff == PRESENCE_ERR )
			return;
		if( diff != DATA_ERR && id[0] == 0x28 ){
			w1_byte_wr( WRITE );			// write command
			w1_byte_wr( '\0' );
			w1_byte_wr( '\0' );
			w1_byte_wr( (uchar)( resolution << 5 ) );
		}
	}

  temp_buffer[DS_TEMP_ERR] = 0; /* Error-Register */
}

void start_meas( void )
{
  if( W1_IN & 1<< W1_PIN ){
    w1_command( CONVERT_T, NULL );
    //W1_OUT |= 1<< W1_PIN;
    //W1_DDR |= 1<< W1_PIN;			// parasite power on
  } else {
    temp_buffer[DS_TEMP_ERR] = 1; /* Error-Register */
	  //softuart_puts( "DS1820: Short Circuit !\r\n" );
  }
}
